//
// AUG98.CPP
//
// This program demonstrates a problem that Microsoft
// Visual C++ 5.0 has keeping track of whether an object
// with static storage and function scope has been properly 
// constructed. The program makes two attempts to access a 
// static object.  The first time through the access
// function getX(), an exception is correctly thrown. 
// However, the second time through the function,
// the constructor is not called, allowing access 
// to an uninitialized object.  Section 6.7 of CD2
// seems to indicate that the object should have its 
// constructor called the second time.
//
// Build this program using the following command line: 
//
// cl /GX AUG98.CPP
//
// Note that Borland C++ 5.01 handles this in the manner 
// we expect, but g++ 2.8.1 exhibits the same behavior 
// as Microsoft.
//
     
#include <iostream>
using namespace std;
     
class X
{
public:
    X(){ throw 1; }
};
     
static X& getX()
{
    static X x;
    return x;
}
     
int main()
{
    cout << "Calling getX()...\n";
    try
    {
        getX();
        cout << "getX() did not throw\n";
    }
    catch (...)
    {
        cout << "getX() threw\n";
    }
    cout << "Calling getX() again...\n"; 
    try
    {
        getX();
        cout << "getX() did not throw\n";
     
     
    }
    catch (...)
    {
        cout << "getX() threw\n";
    }
    return 0;
}

