/*
    vbp2make.c
    w.r.e.c.
    04/19/98
*/

/* c */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


void main (int argc, char *argv [])
{
char szLine     [512],
     szFilename [_MAX_FNAME],
     szFname    [_MAX_FNAME],
     szPath     [_MAX_PATH],
     szExt      [_MAX_EXT],
     szProg     [_MAX_FNAME],
     szSlash    [6],
     szOpt      [8]
;
char *p1,
     *p2,
     *pEnv
;
FILE *f
;

  /* command line argument */
    if (argc < 2)  {
        printf ("Specify .vbp file name\n");
        exit (1);
    }

  /* VB executable set in environment */
    pEnv = getenv ("VB32");
    if (!pEnv)  {
        printf ("Missing VB32 environment variable.\n");
        exit (2);
    }

  /* init */
    strcpy (szSlash,"");

  /* get file name/extension/subdirectory */
    strcpy (szFilename,argv [1]);
    _splitpath (szFilename,NULL,szPath,szFname,szExt);

  /* default if no extension */
    if (strlen (szExt) == 0)  {
        strcpy (szExt,".Vbp");
        strcat (szFilename,szExt);
    }

  /* open file */
    f = fopen (szFilename,"r");
    if (f == NULL)  {
        printf ("File '%s' not found\n",szFilename);
        exit (3);
    }

  /* search for CompatibleEXE32=, ExeName32= */
    strcpy (szProg,"");
    while (fgets (szLine,sizeof (szLine),f) != NULL)  {
      /* replace cr char with null */
        szLine [strlen (szLine)-1] = '\0';
        p1 = strstr (szLine,"CompatibleEXE32=");
        if (p1)  strcpy (szProg,p1+16);
        p2 = strstr (szLine,"ExeName32=");
        if (p2)  {
            strcpy (szProg,szPath);
         /* remove leading/trailing quote */
            if (*(p2+10) == '"')  p2++;
            strcat (szProg,p2+10);
            if (szProg [strlen (szProg)-1] == '"')
               szProg [strlen (szProg)-1] = '\0';
        }
    }

  /* if not found create default */
    if (strlen (szProg) < 1)  {
        strcpy (szProg,szPath);
        strcat (szProg,szFname);
        strcat (szProg,".exe");
    }

    printf ("%s:  \\\n",szProg);

  /* first is always the .vbp file */
    strcpy (szFilename,szFname);
    strcat (szFilename,".vbp");

  /* rewind */
    fseek (f,0,SEEK_SET);

  /* now get filenames which make up project */
    while (fgets (szLine,sizeof (szLine),f) != NULL)  {

      /* replace cr char with null */
        szLine [strlen (szLine)-1] = '\0';

      /* first time thru this is the .vbp */
        if (strlen (szFilename) > 0)  {
            printf ("%s  %s%s  ",szSlash,szPath,szFilename);
            strcpy (szSlash,"  \\\n");
            strcpy (szFilename,"");
        }

        p2 = NULL;

        p1 = strstr (szLine,"IconForm=");
        if (!p1)  {
            p1 = strstr (szLine,"Form=");
            if (p1)  p2 = p1;
        }

        p1 = strstr (szLine,"Module=");
        if (p1)  p2 = p1;

        p1 = strstr (szLine,"Class=");
        if (p1)  p2 = p1;

      /* found? */
        if (p2) {
            p1 = strchr (p2,';');
            if (!p1)  p1 = strchr (p2,'=');
            if (p1)  {
              /* skip space */
                if (*(p1+1) == ' ')  p1++;
                strcpy (szFilename,p1+1);
            }
        }
    }

  /* assume exe, check if dll */
    strcpy (szOpt,"/Make");
    if (strstr (strlwr (szProg),".dll"))
        strcpy (szOpt,"/MakeDLL");

    printf ("\n  %s %s%s %s\n",pEnv,szPath,szFname,szOpt);


  /* all done */
    fclose (f);

}  /* main */

/* eof */

